extends Node2D

@export var collection = false
var id = 1
var faceId = 0

func _ready():
	for i in $"/root/Base/GameManager".gameSave.megamis.size():
		if $"/root/Base/GameManager".gameSave.megamis[i] == 2:
			id = i + 1

func Shake(val: float):
	if !collection:
		$"../Spawner".camShake += val
		$"../Spawner".camShakeTime = 4

func CamMove():
	if !collection:
		$"../Spawner/SpawnerAnim".play("CamMove")

func HideFront():
	if !collection:
		$"../Frontground".visible = false

func OpenPussy(open: bool):
	if !collection:
		$Layers/FrontLayer/Pussy.visible = open

func _on_body_entered(body: Node2D, type: String):
	if body is RigidBody2D:
		match type:
			"Align": body.global_position.x = $Layers.global_position.x
			"Remove": body.queue_free()

func Level(lv = 0):
	if !collection:
		match lv:
			1: if $"../Spawner".layers >= 30: $MegamiAnim.play("%dFace2" % id); return
			2: if $"../Spawner".layers >= 60: $MegamiAnim.play("%dFace3" % id); return
			3: if $"../Spawner".layers >= 100: $MegamiAnim.play("%dFace4" % id); return
			4: if $"../Spawner".layers >= 150: $MegamiAnim.play("%dFace5" % id); return
		$Timer.start()

func GameOver():
	$"../GUI".GameOver(true)

func PlayStage(st = 0):
	match st:
		-1: faceId = 0; $MegamiAnim.play("RESET")
		0: if $MegamiAnim.current_animation != "%dFadeIn" % id and $MegamiAnim.current_animation != "%dFace1" % id: $MegamiAnim.play("%dFadeIn" % id)
		1: if $MegamiAnim.current_animation != "%dFace2" % id: $MegamiAnim.play("%dFace2" % id)
		2: if $MegamiAnim.current_animation != "%dFace3" % id: $MegamiAnim.play("%dFace3" % id)
		3: if $MegamiAnim.current_animation != "%dFace4" % id: $MegamiAnim.play("%dFace4" % id)
		4: if $MegamiAnim.current_animation != "%dFace5" % id: $MegamiAnim.play("%dFace5" % id)

func AnimFinish(anim_name):
	if collection:
		if anim_name == "%dFace5" % id: faceId = 1
		elif anim_name != "RESET" and anim_name != "%dFadeIn" % id: faceId += 1
